# To change this template, choose Tools | Templates
# and open the template in the editor.

$:.unshift File.join(File.dirname(__FILE__),'..','lib')
RAILS_ROOT = File.join(File.dirname(__FILE__),'..','..')

require 'test_helper'
require 'test/unit'
require 'scanner'

puts "Setting up images for testing..."
PATH = File.join(RAILS_ROOT,'test','images_in_test','test_images')
TN_PATH = File.join(RAILS_ROOT,'test','images_in_test','test_tns')

class ScannerTest < Test::Unit::TestCase

  #Prepare images for testing
  def setup
    copy_test_images
    @scanner = Scanner.new(PATH, TN_PATH)
  end

  #Remove images after tests
  def teardown
    remove_test_images
  end

  def test_attr_path
    assert_equal(PATH, @scanner.path)
    assert_equal(TN_PATH, @scanner.tn_path)
  end

  def test_scan_exits
    assert_equal(1,Gallery.count)
    @scanner.scan
    dir_count = Dir[File.join(PATH,"*")].select{|d| File.directory?(d)}.length
    assert_equal(dir_count,Gallery.count)

    #check images quantity
    Gallery.find(:all).each do |gallery|
      assert_equal(Dir[File.join(PATH,gallery.dirname,'*')].length, gallery.images.length)
      assert_equal(Dir[File.join(TN_PATH,gallery.dirname,'*')].length, gallery.images.length)
    end
  end

  private
  def copy_test_images
    remove_test_images
    FileUtils. cp_r(
      File.join(RAILS_ROOT, 'test','test_images'),
      File.join(RAILS_ROOT,'test','images_in_test'))
  end

  def remove_test_images
    FileUtils.rm_rf(PATH)
    FileUtils.mkdir_p(PATH)
    FileUtils.rm_rf(TN_PATH)
    FileUtils.mkdir_p(TN_PATH)
  end
end
